# TPK4186 - Advanced Tools for Performance Engineering
# Main.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# This work is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Table of Contents
# -----------------
# 1. Required modules
# 2. Application

# 1. Required modules
# -------------------

from PERT import *

# 2. Application
# --------------

project = Project()
A = project.RecordActivity("A", "Agreement of the owner", 4, [])
B = project.RecordActivity("B", "Preparation of the ground", 2, [])
C = project.RecordActivity("C", "Order of materials", 1, [A])
D = project.RecordActivity("D", "Excavation", 1, [A, B])
E = project.RecordActivity("E", "Order of doors and windows", 2, [A])
F = project.RecordActivity("F", "Delivery of materials", 2, [C])
G = project.RecordActivity("G", "Concrete foundations", 2, [D, F])
H = project.RecordActivity("H", "Delivery of doors and windows", 10, [E])
J = project.RecordActivity("J", "Frame, roofs, walls", 4, [G])
K = project.RecordActivity("K", "Installation of doors and windows", 1, [H, J])

project.ComputeEarlyDates()
project.ComputeLateDates()

print("Actities")
print("Name\tDur.\tESD\tECD\tLSD\tLCD\tCrit.")
for activity in project.GetActivities():
  if activity.IsCritical():
    criticality = "yes"
  else:
    criticality = "no"
  print("{0}\t{1:d}\t{2:d}\t{3:d}\t{4:d}\t{5:d}\t{6}".format(
    activity.GetName(),
    activity.GetDuration(),
    activity.GetEarlyStartingDate(),
    activity.GetEarlyCompletionDate(),
    activity.GetLateStartingDate(),
    activity.GetLateCompletionDate(),
    criticality))
print("---")
print("Project\t{0:d}".format(project.GetEarlyCompletionDate()))



